{************************************************************************
   Ricardo Santiago Cachero (RSC). November 1996.
   FormEditor v 1.0. for Delphi 2.x

   Forms editor to desing you Form in RUN-TIME.
   This object let you to design a form or a part of form like
   Panels, or any other object wich can contain other components.

   How FormEditor derive directly from TForm, you can use all methods,
   events and properies create in Tform, and the new what I create for
   FormEditor.

   The new properties are :

       DesingComponent : ( TList )
            define the list of parents components who can be edited.

       EditMode: ( Boolean )
            Change between EditMode and RunMode.

       XGRID and YGRID : ( Integer )
            define the distance in pixels of the virtual
            grid to adjust components.


   The new Events are :

       OnSelectObject :
            Notify when you select a object.

       OnMovingOnject :
            Notify when a component is moving.

To INSTALL :
    You only must comnpile de FormEditor Unit and put it on then Lib
    directory of Delphi 2.0.

    To make a Form TFormDsg, you only must derive form TFormDsg you
    new form.

REMEMBER:
    This software if freeware and it may have same Bugs.

IMPORTANT:
    Please if find a bug e-mail me.

    This SoftWare is for non comercial use, but when you use this please
    e-mail me :

       < rsantiag@sp-editores.es >

    I like know where my " mind is running ".

************************************************************************}

unit FormEditor;

interface

uses SysUtils, Classes, Controls, Forms, Graphics, Messages,
     Windows, DIalogs, Buttons, StdCtrls, ExtCtrls;
type

   TEditObjectEvent = procedure(Sender: TObject;
                                  Component : TComponent) of object;

   TFormDsg = class( TForm )
   protected
     dotNW, dotN, dotNE, dotW, dotE, dotSW, dotS, dotSE : TForm;
     MPoint          : TPoint;
     newPos          : TRect;
     Moving          : Boolean;
     oList           : TList;
     oMovControl     : TForm;
     fxGrid          : Integer;
     fyGrid          : Integer;
     fDesingCompo    : TList;
     fEditMode       : Boolean;
     fOnSelectObject : TEditObjectEvent;
     fOnMovingObject : TEditObjectEvent;
     procedure DotMouseDown( Sender: TObject;
                             Button: TMouseButton;
                             Shift: TShiftState;
                             X, Y: Integer);
     procedure DotMouseUp( Sender: TObject;
                           Button: TMouseButton;
                           Shift: TShiftState;
                           X, Y: Integer);
     procedure DotMouseMove(Sender: TObject;
                            Shift: TShiftState;
                            X, Y: Integer);
     procedure HideDots;
     procedure RefreshDots;
     procedure ShowDots;
     procedure CTRLDrawFocus(oListDraw : TList;
                             wMRow, wmCOl : Integer;
                             wMResize : TForm );
     function FindByPoint(x , y : Integer;
                          Compo : TComponent ) : TControl;
     procedure GetComponents( Compo : TComponent ; var List : Tlist);
     function GetComponentCount( Compo : TComponent) : Integer;
     procedure ControlToForm( control : TControl; var x , y : Integer );
   private
     procedure WndProc(var Message: TMessage); override;
     procedure WMCaptureChanged(var Message: TMessage); message WM_CAPTURECHANGED;
   public
     constructor Create(AOwner: TComponent); override;
     destructor Destory;
   published
     property DesingComponent : TList read fDesingCompo write fDesingCompo;
     property EditMode : Boolean read fEditMode Write fEditMode;
     property XGrid : Integer read fXGrid write fXGrid;
     property YGrid : Integer read fYGrid write fYGrid;

     property OnSelectObject : TEditObjectEvent read fOnSelectObject
                                                  write fOnSelectObject;
     property OnMovingObject : TEditObjectEvent read fOnMovingObject
                                                  write fOnMovingObject;
end;

const
     RES_NW  = 1;
     RES_N   = 2;
     RES_NE  = 3;
     RES_E   = 4;
     RES_SE  = 5;
     RES_S   = 6;
     RES_SW  = 7;
     RES_W   = 8;
Type
   PActiveFormDsg = ^TActiveFormDsg;
   TActiveFormDsg   = record
     Actual, Next: Pointer;
  end;

var
  FormCreated : PActiveFormDsg = nil;

implementation

//----------------------------------------------------------------------//
constructor TFormDsg.Create(AOwner: TComponent);
var
   pNew, pPrior : PActiveFormDsg;
begin
   inherited Create( AOwner );

   oList := Tlist.Create;

   if dotNW = nil then
   begin
      dotNW             := TForm.Create( Application );
      dotNW.Color       := clBlack;
      dotNW.BorderStyle := bsNone;
      dotNW.Width       := 5;
      dotNW.Height      := 5;
      dotNW.cursor      := crSizeNWSE;
      dotNW.FormStyle   := fsStayOnTop;
      dotNW.OnMouseDown := DotMouseDown;
      dotNW.OnMouseUp   := DotMouseUp;
      dotNW.OnMouseMove := DotMouseMove;

      dotN             := TForm.Create( Application );
      dotN.Color       := clBlack;
      dotN.BorderStyle := bsNone;
      dotN.Width       := 5;
      dotN.Height      := 5;
      dotN.cursor      := crSizeNS;
      dotN.FormStyle   := fsStayOnTop;
      dotN.OnMouseDown := DotMouseDown;
      dotN.OnMouseUp   := DotMouseUp;
      dotN.OnMouseMove := DotMouseMove;

      dotNE             := TForm.Create( Application );
      dotNE.Color       := clBlack;
      dotNE.BorderStyle := bsNone;
      dotNE.Width       := 5;
      dotNE.Height      := 5;
      dotNE.cursor      := crSizeNESW;
      dotNE.FormStyle   := fsStayOnTop;
      dotNE.OnMouseDown := DotMouseDown;
      dotNE.OnMouseUp   := DotMouseUp;
      dotNE.OnMouseMove := DotMouseMove;

      dotW             := TForm.Create( Application );
      dotW.Color       := clBlack;
      dotW.BorderStyle := bsNone;
      dotW.Width       := 5;
      dotW.Height      := 5;
      dotW.cursor      := crSizeWE;
      dotW.FormStyle   := fsStayOnTop;
      dotW.OnMouseDown := DotMouseDown;
      dotW.OnMouseUp   := DotMouseUp;
      dotW.OnMouseMove := DotMouseMove;

      dotE             := TForm.Create( Application );
      dotE.Color       := clBlack;
      dotE.BorderStyle := bsNone;
      dotE.Width       := 5;
      dotE.Height      := 5;
      dotE.cursor      := crSizeWE;
      dotE.FormStyle   := fsStayOnTop;
      dotE.OnMouseDown := DotMouseDown;
      dotE.OnMouseUp   := DotMouseUp;
      dotE.OnMouseMove := DotMouseMove;

      dotSW             := TForm.Create( Application );
      dotSW.Color       := clBlack;
      dotSW.BorderStyle := bsNone;
      dotSW.Width       := 5;
      dotSW.Height      := 5;
      dotSW.cursor      := crSizeNESW;
      dotSW.FormStyle   := fsStayOnTop;
      dotSW.OnMouseDown := DotMouseDown;
      dotSW.OnMouseUp   := DotMouseUp;
      dotSW.OnMouseMove := DotMouseMove;

      dotS             := TForm.Create( Application );
      dotS.Color       := clBlack;
      dotS.BorderStyle := bsNone;
      dotS.Width       := 5;
      dotS.Height      := 5;
      dotS.cursor      := crSizeNS;
      dotS.FormStyle   := fsStayOnTop;
      dotS.OnMouseDown := DotMouseDown;
      dotS.OnMouseUp   := DotMouseUp;
      dotS.OnMouseMove := DotMouseMove;

      dotSE             := TForm.Create( Application );
      dotSE.Color       := clBlack;
      dotSE.BorderStyle := bsNone;
      dotSE.Width       := 5;
      dotSE.Height      := 5;
      dotSE.cursor      := crSizeNWSE;
      dotSE.FormStyle   := fsStayOnTop;
      dotSE.OnMouseDown := DotMouseDown;
      dotSE.OnMouseUp   := DotMouseUp;
      dotSE.OnMouseMove := DotMouseMove;
   end;

   fDesingCompo := TList.Create;
   fEditMode := False;

   { Grids por defecto }
   xGrid := 4;
   yGrid := 4;

   moving := False;
   if ( FormCreated = nil ) then begin
      new( pNew );
      pNew^.Actual := self;
      pNew^.Next := nil;
      FormCreated := pNew;
   end else begin
      pNew := FormCreated;
      pPrior := nil;
      while pNew <> nil do begin
         pPrior := pNew;
         pNew  := pNew^.Next;
      end;
      new( pNew );
      pNew^.Actual := self;
      pNew^.Next := nil;
   end;
end;

//----------------------------------------------------------------------//
destructor TFormDsg.Destory;
var
   pNew, pPrior : PActiveFormDsg;
begin
   inherited destroy;

   oList.Free;

   pNew := FormCreated;
   pPrior := nil;
   while pNew <> nil do begin
      if ( pNew.Actual = Self )then begin
         if ( pPrior = nil) then
            FormCreated := pNew.Next
         else
            pPrior.Next := pNew.Next;
         dispose(pNew);
         exit;
      end;
      pPrior := pNew;
      pNew  := pNew^.Next;
   end;
   new( pNew );
   pNew^.Actual := self;
   pNew^.Next := nil;
end;

//----------------------------------------------------------------------//
procedure TFormDsg.DotMouseDown( Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   HideDots;
   MPoint.x      := x;
   MPoint.y      := y;
   MPoint := TForm(Sender).ClientToScreen(MPoint);

   if ( oList.Count = 1 ) then
     CTRLDrawFocus(oList, y, x, nil );
end;

//----------------------------------------------------------------------//
procedure TFormDsg.DotMouseUp( Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   ctrl : TControl;
begin
   if ( oList.Count = 1 ) then begin
     CTRLDrawFocus(oList, y, x, nil );
     ctrl := TControl (oList.Items[0]);

     ctrl.Left   := NewPos.Left;
     ctrl.Top    := NewPos.Top;
     ctrl.Width  := NewPos.Right - NewPos.left;
     ctrl.Height := NewPos.Bottom - NewPos.Top;
     ctrl.Parent.Refresh;
     ctrl.Refresh;

     RefreshDots;
   end;

   ShowDots;
end;

//----------------------------------------------------------------------//
procedure TFormDsg.DotMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   MNewPoint : TPoint;
   MAdGrid   : TPoint;
   PointT    : TPoint;
begin
   MNewPoint.x := x;
   MNewPoint.y := y;
   MNewPoint   := TForm(Sender).ClientToScreen(MNewPoint);

   MAdGrid.x := MNewPoint.x - MPoint.x;
   MAdGrid.y := MNewPoint.y - MPoint.y;

   MAdGrid.x := xGrid *(MAdGrid.x div xGrid);
   MAdGrid.y := yGrid *(MAdGrid.y div yGrid);

   if ( ( oList.Count = 1 ) and ( ssLeft in shift ) ) then begin
      if ( (MAdGrid.x<>0) or (MAdGrid.y<>0)  ) then
            CTRLDrawFocus(oList , y, x, nil );

     {  Dot NORTE  }
     if ( (Sender = dotN) or (Sender = dotNE) or (Sender = dotNW) ) then  begin
        NewPos.Top := NewPos.Top + MAdGrid.y;
     end;

     {  Dot Sur }
     if ( ( Sender = dotS )or (Sender = dotSE) or (Sender = dotSW) ) then  begin
        NewPos.Bottom := NewPos.Bottom + MAdGrid.y;
     end;

     {  Dot Este }
     if ( ( Sender = dotE )or (Sender = dotNE) or (Sender = dotSE) ) then  begin
        NewPos.Right := NewPos.Right + MAdGrid.x;
     end;

     {  Dot Oeste }
     if ( ( Sender = dotW ) or (Sender = dotSW) or (Sender = dotNW)) then  begin
        NewPos.Left := NewPos.Left + MAdGrid.x;
     end;


     if ( MAdGrid.x <> 0 ) then begin
        PointT.x := x;
        PointT.y := 0;
        PointT := TForm(Sender).ClientToScreen(PointT);

        MPoint.x := PointT.x;
     end;

     if ( MAdGrid.y <> 0 ) then begin
        PointT.y := y;
        PointT.x := 0;
        PointT := TForm(Sender).ClientToScreen(PointT);

        MPoint.y := PointT.y;
     end;
     if ( (MAdGrid.x<>0) or (MAdGrid.y<>0)  ) then
            CTRLDrawFocus(oList , y, x, TForm( Sender ) );
   end;

end;

//----------------------------------------------------------------------//
procedure TFormDsg.HideDots;
begin
   dotNW.Visible := FALSE;
   dotN.Visible  := FALSE;
   dotNE.Visible := FALSE;
   dotW.Visible  := FALSE;
   dotE.Visible  := FALSE;
   dotSW.Visible := FALSE;
   dotS.Visible  := FALSE;
   dotSE.Visible := FALSE;
end;

//----------------------------------------------------------------------//
procedure TFormDsg.ShowDots;
begin
   if (oList.Count = 1 ) then begin
     dotNW.Visible := TRUE;
     dotN.Visible  := TRUE;
     dotNE.Visible := TRUE;
     dotW.Visible  := TRUE;
     dotE.Visible  := TRUE;
     dotSW.Visible := TRUE;
     dotS.Visible  := TRUE;
     dotSE.Visible := TRUE;
   end;
end;

//----------------------------------------------------------------------//
procedure TFormDsg.RefreshDots;
var
  Point : TPoint ;
begin
   Point.x := TControl(oList.Items[0]).left;
   Point.y := TControl(oList.Items[0]).Top;
   { Convertir a coordenadas de form }
   ControlToForm( oList.Items[0], Integer(Point.x) , Integer(Point.y) );
   { Convertir a coordenadas de screen }
   Point := ClientToScreen( Point );

   dotNW.top  := Point.y  - 2;
   dotNW.left := Point.x - 2;
   dotN.top   := Point.y  - 2;
   dotN.left  := Point.x - 2 + ( TControl(oList.Items[0]).Width div 2 );
   dotNE.top  := Point.y  - 2;
   dotNE.left := Point.x - 3 + ( TControl(oList.Items[0]).Width );
   dotW.top   := Point.y  - 2 + ( TControl(oList.Items[0]).Height div 2 );
   dotW.left  := Point.x - 2;
   dotE.top   := Point.y  - 2 + ( TControl(oList.Items[0]).Height div 2 );
   dotE.left  := Point.x - 3 + ( TControl(oList.Items[0]).Width );
   dotSW.top  := Point.y  - 3 + ( TControl(oList.Items[0]).Height );
   dotSW.left := Point.x - 2;
   dotS.top   := Point.y  - 3 + ( TControl(oList.Items[0]).Height );
   dotS.left  := Point.x - 2 + ( TControl(oList.Items[0]).Width div 2 );
   dotSE.top  := Point.y  - 3 + ( TControl(oList.Items[0]).Height );
   dotSE.left := Point.x - 3 + ( TControl(oList.Items[0]).Width );
end;

//----------------------------------------------------------------------//
procedure TFormDsg.WndProc(var Message: TMessage);
var
   MNewPoint : TPoint;
   MAdGrid   : TPoint;
   PointT    : TPoint;
   I         : Integer;
   oTempComp : TControl;
   isMsg     : Boolean;
   oCtrl     : TControl;
   Rect      : TRect;
   pNew      : PActiveFormDsg;
   DKey      : Word;
begin
   if ( FormCreated = nil ) then begin
      inherited WndProc( Message );
      exit;
   end else begin
      if (fEditMode = False ) then begin
        inherited WndProc( Message );
        exit;
      end;

      pNew := FormCreated;
      while pNew <> nil do begin
         if ( (pNew.ACtual <> Self) and (pNew^.Next = nil) ) then begin
           inherited WndProc( Message );
           exit;
         end;
         pNew  := pNew^.Next;
      end;
   end;

   oCtrl := nil;

   if ( ( ( Message.Msg = WM_PARENTNOTIFY)
           and ( TWMParentNotify(Message).Event = WM_LBUTTONDOWN ) ) or
        ( Message.Msg = WM_LBUTTONDOWN  ) ) then begin

     { Buscar el componente Correspondiente }
         with TWMLButtonDown(Message) do
           oCtrl := FindByPoint(XPos,YPos, Self);

     { ---- Comprobar si el control pertenece a alguno de los
          que estan en diseo ------------------------------}

     isMsg := False;

     if ( fDesingCompo.Count = 0 ) then
        fDesingCompo.Add( Application.MainForm);

     for i :=0 to fDesingCompo.Count - 1 do begin
        oTempComp := oCtrl;
        while (oTempComp <> nil) do begin
            if ( ( oTempComp = fDesingCompo.Items[ i ] )
                and ( oCtrl <> fDesingCompo.Items[ i ] ) ) then begin
               isMsg := True;
               Break;
            end;
            oTempComp := oTempComp.parent;
        end;
        if ( isMsg = True ) then
           break;
     end;

     if ( ( oCtrl = nil ) or (isMsg = False ) ) then begin
        {  Si el componente no esta en diseo, no hacer nada }
        HideDots;
        oMovControl := nil;
        Windows.ReleaseCapture;
        inherited WndProc( Message );
        exit;
     end;
   end;

   { ---- Mensage -------------}
   if ( ( TWMParentNotify(message).Event = WM_LBUTTONDOWN ) or
        ( Message.Msg = WM_LBUTTONDOWN  )  ) then
   begin
      Windows.SetCapture(Self.Handle);
      HideDots;

      if ( oCtrl = Application.MainForm )  then begin
        oMovControl := Nil;
        oList.Clear;
        exit;
      end;

      if ( Message.Msg = WM_LBUTTONDOWN ) then
        DKey := Message.WParam
      else
        DKey := 0 ;

      oMovControl := TForm( oCtrl);
      NewPos.Left   := oCtrl.Left;
      NewPos.Top    := oCtrl.Top;
      NewPos.Right  := oCtrl.Width + oCtrl.Left - 1;
      NewPos.Bottom := oCtrl.Height + oCtrl.Top - 1;

      if (DKey <> MK_Shift ) then begin
        oList.Clear;
      end;

      oList.Add(oMovControl);

      MPoint.x      := TWMParentNotify(message).XPos;
      MPoint.y      := TWMParentNotify(message).YPos;
      MPoint := oCtrl.ClientToScreen(MPoint);

      Moving := True;
      if (oCtrl <> nil) then
          CTRLDrawFocus(oList , TWMParentNotify(message).XPos,
                        TWMParentNotify(message).YPos, nil );

      if Assigned(FOnSelectObject) then
         FOnSelectObject(Self, oCtrl);
      exit;
   end;

   { ---- Mensage -------------}
   if ( ( Message.Msg = WM_MOUSEMOVE ) and ( Message.Wparam = MK_LBUTTON) and
       (oMovControl <> nil) ) Then begin

      MNewPoint.x := Message.LparamLo;
      MNewPoint.y := Message.LparamHi;
      MNewPoint   := TControl(oList.Items[0]).ClientToScreen(MNewPoint);

      {================================================}
      {  Moviendo el raton para desplazar objeto.      }
      {================================================}
      MAdGrid.x := MNewPoint.x - MPoint.x;
      MAdGrid.y := MNewPoint.y - MPoint.y;

      MAdGrid.x := xGrid *(MAdGrid.x div xGrid);
      MAdGrid.y := yGrid *(MAdGrid.y div yGrid);

      if ( (MAdGrid.x<>0) or (MAdGrid.y<>0)  ) then
            CTRLDrawFocus(oList, Message.LparamHi,
                          Message.LparamLo, nil );
      with NewPos do begin
        Left   := Left + MAdGrid.x;
        Top    := Top + MAdGrid.y;
        Right  := Right + MAdGrid.x;
        Bottom := Bottom + MAdGrid.y;
      end;

      if ( MAdGrid.x <> 0 ) then begin
         PointT.x := Message.LparamLo;
         PointT.y := 0;
         PointT := TControl(oList.Items[0]).ClientToScreen(PointT);

         MPoint.x := PointT.x;
      end;

      if ( MAdGrid.y <> 0 ) then begin
         PointT.y := Message.LparamHi;
         PointT.x := 0;
         PointT := TControl(oList.Items[0]).ClientToScreen(PointT);

         MPoint.y := PointT.y;
      end;
      if ( (MAdGrid.x<>0) or (MAdGrid.y<>0)  ) then
              CTRLDrawFocus(oList , Message.LparamHi,
                           Message.LparamLo, nil );

      if Assigned(FOnMovingObject) then
         FOnSelectObject(Self, oCtrl);

      exit;
   end else
     if ( ( Message.Msg = WM_MOUSEMOVE ) and (Moving = True) and
           ( Message.Wparam <> MK_LBUTTON) ) then begin
        oMovControl := Nil;
        oList.Clear;

        oTempComp.Refresh;
     end;

   { ---- Mensage -------------}
   if  ( Message.Msg = WM_LBUTTONUP ) Then begin
      Windows.ReleaseCapture;
      Moving := False;
   end;

   if ( ( Message.Msg = WM_LBUTTONUP ) and (oMovControl <> nil)) then
   begin
      Moving := False;
      Windows.ReleaseCapture;
      CTRLDrawFocus(oList , Message.LparamHi, Message.LparamLo, nil );
      MPoint.x := NewPos.Left;
      MPoint.y := NewPos.Top;

      TControl(oList.Items[0]).Left := MPoint.x;
      TControl(oList.Items[0]).Top  := MPoint.y;

      RefreshDots;
      ShowDots;

      TControl(oList.Items[0]).Parent.Refresh;
      TControl(oList.Items[0]).Refresh;
      Self.SetFocus;
      exit;
   end;

   inherited WndProc( Message );
end;

//----------------------------------------------------------------------//
procedure TFormDsg.WMCaptureChanged(var Message: TMessage);
begin
   if ( ( HWND (Message.LParam) <> Self.Handle ) and ( moving = True ) ) then
     Windows.SetCapture( Self.Handle );
end;

//----------------------------------------------------------------------//
procedure TFormDsg.CTRLDrawFocus(oListDraw : TList; wMRow, wmCOl : Integer;
             wMResize : TForm );
var
   hWndParent : HWND;
   hdc2       : HDC;
   rct        : TRECT;
   pt         : TPOINT;
   hReg       : HRGN;
   hBr        : HBRUSH;
   iRop       : Integer;
   wRow       : Integer;
   wCol       : Integer;
   oControl   : TControl;

   begin

   HideDots;

   if (oListDraw.Count = 1  ) then begin
     oControl := TControl( oListDraw.Items[0] );

     hWndParent := oControl.Parent.Handle;
     hBr := CreateSolidBrush( RGB( 127, 127, 127 ) );
     wRow := oControl.Top;
     wCol := oControl.Left;

     GetWindowRect( oControl.Parent.Handle , rct );

     if( (wMResize = nil ) or  ( ( wRow = 0 ) and ( wCol = 0  ) ) ) then begin
        rct.Bottom := rct.Bottom + wRow;
        rct.Right  := rct.Right + wCol;
        rct.Top    := rct.Top + wRow;
        rct.Left   := rct.Left + wCol;
     end else begin
        pt.x := wMCol;
        pt.y := wMRow;
        Windows.ClientToScreen( oControl.Parent.Handle, pt );
        wMRow := pt.y;
        wMCol := pt.x;

        if ( wMResize = DotNW ) Then begin
              rct.Top  := wMRow;
              rct.Left := wMCol;
        end else
           if ( wMResize = DotN ) then begin
                rct.Top := wMRow;
           end else
              if ( wMResize =DotNE ) then begin
                 rct.Top   := wMRow;
                 rct.Right := wMCol;
              end else
                 if ( wMResize = DotE ) then begin
                    rct.Right := wMCol;
                 end else
                   if ( wMResize = DotSE ) then begin
                      rct.Bottom := wMRow;
                      rct.Right  := wMCol;
                   end else
                      if ( wMResize = DotS ) then begin
                       rct.Bottom := wMRow;
                      end else
                        if ( wMResize = DotSW ) then begin
                           rct.Bottom := wMRow;
                           rct.Left   := wMCol;
                        end else
                           if ( wMResize = DotW ) then begin
                             rct.Left := wMCol;
                           end;
     end;
     pt.x := rct.Left;
     pt.y := rct.Top;

     rct := NewPos;

     hReg := CreateRectRgn( rct.Left - 2, rct.Top - 2, rct.Right + 2, rct.Bottom + 2 );
     hdc2  := GetDCEx( hWndParent, hReg, DCX_CACHE );
     iRop := SetROP2( hdc2, R2_XORPEN );
     FrameRgn( hdc2, hReg, hBr, 2, 2 );
     SetROP2( hdc2, iRop );
     ReleaseDC( hWndParent, hdc2 );
     DeleteObject( hReg );
     DeleteObject( hBr );

     exit;
   end;
end;

//----------------------------------------------------------------------//
function TFormDsg.FindByPoint(x , y : Integer; Compo : TComponent ) : TControl;
var
   iCom   : Integer;
   Lista  : Tlist;
   iLeft,iTop : integer;
begin
   result := nil;
   Lista  := TList.Create;
   GetComponents( Compo , Lista);


   for iCom := 0 to Lista.Count -1 do begin
      { Calcular coordenadas con respecto a la ventana de diseo }
      ControlToForm(TControl(Lista.Items[iCom]), iLeft, iTop);

      if ( ( x >= iLeft ) and
           ( x <= iLeft + TControl(Lista.Items[iCom]).Width ) and
           ( y >= iTop ) and
           ( y <= iTop + TControl(Lista.Items[iCom]).Height )
          ) then begin
            if ( GetComponentCount( TComponent(Lista.Items[iCom]) ) > 0 ) then begin
                result := FindByPoint( x, y,
                                       TComponent(Lista.Items[iCom]));
                break;
            end else begin
               result := TControl(Lista.Items[iCom]);
               break;
            end;
      end;
   end;

   Lista.Free;
end;

//----------------------------------------------------------------------//
procedure TFormDsg.GetComponents( Compo : TComponent ; var List : Tlist);
var
  iC : Integer;
begin
   if ( List = nil ) then
      List := TList.Create;

   List.Clear;
   for iC := 0 to ComponentCount -1 do
      if ( TControl(Components[iC]).parent = Compo ) then
            List.Add( Components[iC] );
end;

//----------------------------------------------------------------------//
function TFormDsg.GetComponentCount( Compo : TComponent) : Integer;
var
   iC : INteger;
begin
   result := 0;
   for iC := 0 to ComponentCount -1 do
      if ( TControl(Components[iC]).parent = Compo ) then
            inc(result);
end;

//----------------------------------------------------------------------//
procedure TFormDsg.ControlToForm( control : TControl; var x , y : Integer );
var
   oTCtrl : TControl;
begin
      { Calcular coordenadas con respecto a la ventana de diseo }
      oTCtrl := Control;
      x := 0;
      y := 0;

      while ( oTctrl <> self ) do begin
        x := x + oTCtrl.Left;
        y := y + oTCtrl.Top;
        oTCtrl := Tcontrol(oTCtrl.parent);
      end;
end;

end.
